interface Collection<T> {
    [key: string]: T;
}
export declare function watchCollection<T extends Indexed>(collection?: Collection<T>): Collection<T> & Sub<T>;
interface Indexed {
    id: string;
}
export interface Sub<T extends Indexed> {
    subscribe(cb: SubscriptionCallback<T>, subscription?: Subscription<T>): Unsubscribe;
    unsubscribe(cb: SubscriptionCallback<T>): void;
    add(item: T): T;
    remove(item: T): T | undefined;
    find(name: string): T | undefined;
}
export declare type SubscriptionCallback<T> = () => void;
export declare type Unsubscribe = () => void;
export declare type Subscription<T> = {
    [P in keyof T]?: boolean;
};
export {};
