export declare function watch<T extends object>(target: T): T & Sub<T>;
export interface Sub<T> {
    subscribe(cb: SubscriptionCallback<T>, subscription?: Subscription<T>): Unsubscribe;
    unsubscribe(cb: SubscriptionCallback<T>): void;
}
export declare type SubscriptionCallback<T> = (t: T) => void;
export declare type Unsubscribe = () => void;
export declare type Subscription<T> = {
    [P in keyof T]?: boolean;
};
